{
 ASMetr Component 1.3 Copyright  1998
       Andrey Abakumov (aga@novoch.ru)

The ASMetr this Scale of measurement of a
type "speedmetr".

Properties:
 Position    - current position on the switch;
 Sliding     - scale
 Max         - maximum value (up to 270)
               (Min - allways zero);
 PrintValues - to print or not print values

 AttenZonePos - "Zone of attention";
 DangerZonePos - "Dangerous zone";
 AttenZoneColor -  Colour of a "zone of attention";
 DangerZoneColor - Colour of a "dangerous zone";

 SoundType       - disabled playing if SoundType=wssNone
                   of a sound at switching,
                   enabled and (SoundType=wssExe) to keep in EXE the file,
                   enabled and (SoundType=wssWav) to keep in Wav the file,

 AttenZoneSound - choice of a sound file or sound resource
                  for want of reaching of a zone of attention
 DangerZoneSound - choice of a sound file or sound resource
                  for want of reaching of a zone of danger
 OverflowSound - choice of a sound file or sound resource
                  for want of reaching of overflow

 ResourceType - type of a resource if SoundType=wssExe

 WaveOptions -
               woSync      - The sound is played synchronously and the
                             function does not return until the sound ends.
               woNoDefault - If the sound can't be found, the function returns
                             silently without playing the default sound.
               woLoop      - The sound will continue to play repeatedly.
               woNoStop    - If a sound is currently playing, the function
                             will immediately return FALSE without playing
                             the requested sound.

How to make *.WAV in resource?

Create file filename.rc
For example:
CLICK WAVE filename.wav - CLICK is resource name, WAVE is your filetype, plus filename
To create *.res file (brcc32 filename.rc)

In Object Inspector, AASwitcher properties must be defined as follows:
CLICK WAVE
      ^^^         - you must specify ResourceType property
^^^^^             - you must specify ResourceName.
Also select sound type eg WssEXE

To include resource in our EXE place after {$R *.DFM}
//{$R yourresourcefilename.res} <---Insert the following without the comments(//)


{    I take no responsibility for any losses suffered
resulting from use or misuse of this code.It is freeware,
with source code, and so you use (and maintain) it at
your own risk.
}
unit ASMetr;

interface

uses
  {$IFDEF WIN32}
   Windows,
  {$ELSE}
   WinTypes,
   WinProcs,
  {$ENDIF}
  SysUtils,Messages, Classes, Graphics, Controls,
  Forms, Dialogs,DsgnIntf,MMSystem,ASFunc;

type
  TASSoundFileChange = class(TStringProperty)
     function GetAttributes:TPropertyAttributes;override;
     procedure Edit;override;
    end;

  TASMetr = class(TGraphicControl)
  private
    { Private declarations }
    FPosition:Integer;
    FMax:Integer;
    FSliding:Integer;
    FPrintValues:Boolean;
    FAttenZoneSound:String;
    FDangerZoneSound:String;
    FOverflowSound:String;

    FSoundType:TWhereSoundStore;
    FResourceType :String;
    FWaveOptions:Word;
    FPalyOptions:TWaveOptions;


    FAttenZonePos:Integer;
    FDangerZonePos:Integer;
    FAttenZoneColor:TColor;
    FDangerZoneColor:TColor;

    Procedure SetPosition(Value:Integer);
    Procedure SetMax(Value:Integer);
    Procedure SetSliding(Value:Integer);
    Procedure SetPrintValues(Value:Boolean);

    Procedure SetAttenZoneSound(Value:String);
    Procedure SetDangerZoneSound(Value:String);
    Procedure SetOverflowSound(Value:String);

    Procedure SetSoundType(Value:TWhereSoundStore);
    Procedure SetResourceType(Value:String);

    Procedure SetAttenZonePos(Value:Integer);
    Procedure SetDangerZonePos(Value:Integer);
    Procedure SetAttenZoneColor(Value:TColor);
    Procedure SetDangerZoneColor(Value:TColor);

  protected
    { Protected declarations }
   Procedure DrawFace;virtual;
   Procedure DrawTicks;virtual;
   Procedure DrawPointer;virtual;

   Procedure Paint;override;
  public
    { Public declarations }
   Constructor Create(AOwner:TComponent);override;
  published
    { Published declarations }
    property Position:Integer
             read FPosition
             write SetPosition
             default 1;

    property Max:Integer
             read FMax
             write SetMax
             default 10;

    property Sliding:Integer
             read FSliding
             write SetSliding
             default 1;

    property PrintValues:Boolean
             read FPrintValues
             write SetPrintValues
             default False;

    property AttenZoneSound:String
             read FAttenZoneSound
             write SetAttenZoneSound;

    property DangerZoneSound:String
             read FDangerZoneSound
             write SetDangerZoneSound;

    property OverflowSound:String
             read FOverflowSound
             write SetOverflowSound;

    property SoundType:TWhereSoundStore
             read FSoundType
             write SetSoundType
             default wssWav;

    property ResourceType:String
             read FResourceType
             write SetResourceType;

    property WaveOptions:TWaveOptions
             read FPalyOptions
             write FPalyOptions
             default [woSync,woNoDefault,woNoStop];

    property AttenZonePos:Integer
             read FAttenZonePos
             write SetAttenZonePos
             default 7;

    property DangerZonePos:Integer
             read FDangerZonePos
             write SetDangerZonePos
             default 9;

    property AttenZoneColor:TColor
             read FAttenZoneColor
             write SetAttenZoneColor
             default clMaroon;

    property DangerZoneColor:TColor
             read FDangerZoneColor
             write SetDangerZoneColor
             default clRed;

  end;
Var
   sA,eA:TPoint;
   PositionOld,
   PositionNatur:Integer;
   Dest:TRect;

procedure Register;

implementation
{------------ TASSoundFileChange -----------}
Function TASSoundFileChange.GetAttributes:TPropertyAttributes;
begin
Result := inherited GetAttributes + [paDialog];
end;

Procedure TASSoundFileChange.Edit;
var
   Dialog:TOpenDialog;
begin
Dialog:=TOpenDialog.Create(Application);
Dialog.Filter:='Sound files|*.wav';
Dialog.Title:='Open sound file';
If Dialog.Execute
 Then SetStrValue(Dialog.FileName);
Dialog.Free;
end;

Constructor TASMetr.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
 FMax:=10;
 FSliding:=1;
 FPosition:=0;
 Width:=150;
 Height:=150;
 Offset:={60}5;
 Offset2:=Round(Offset+15);
 Offset4:=Round(Offset+10);
 FPrintValues:=False;

 FAttenZonePos:=7;
 FDangerZonePos:=9;
 FAttenZoneColor:=clMaroon;
 FDangerZoneColor:=clRed;
 
 SoundType:=wssWav;
 WaveOptions:=[woSync,woNoDefault,woNoStop];

end;

Procedure TASMetr.DrawFace;
begin
 With Canvas Do
  begin
  Pen.Color:=$00909090;
  Brush.Color:=$00909090;
  Brush.Style:=bsSolid;
  Pen.Width:=2;

  GradValues(TickCount);
  StartA:=270+Trunc(p2 / 2);
  EndA:=270-Trunc(p2 / 2);

  GradValues(TickCount);//*
  iGrad:=Trunc(t1);     //*

  EndA:=270-Trunc(p2 / 2);
  EndA:=EndA+360-(iGrad*(FDangerZonePos {div FSliding}));//*

  GradToCoords(StartA,EndA,sA,eA);
  Brush.Color:=FDangerZoneColor;
  Pie(Offset,Offset,Width-Offset,Height-Offset,
      midX+sA.X,midY-sA.Y,midX+eA.X,midY-eA.Y);

  EndA:=270-Trunc(p2 / 2);
  StartA:=EndA+360-(iGrad*(FAttenZonePos {div FSliding}));
  EndA:=EndA+360-(iGrad*(FDangerZonePos {div FSliding}));

  GradToCoords(EndA,StartA,sA,eA);
  Brush.Color:=FAttenZoneColor;
  Pie(Offset,Offset,Width-Offset,Height-Offset,
      midX+sA.X,midY-sA.Y,midX+eA.X,midY-eA.Y);

  EndA:=270-Trunc(p2 / 2);
  EndA:=EndA+360-(iGrad*(0 {div FSliding}));

  GradToCoords(StartA,EndA,sA,eA);
  Brush.Color:=clGreen;
  Pie(Offset,Offset,Width-Offset,Height-Offset,
      midX+sA.X,midY-sA.Y,midX+eA.X,midY-eA.Y);

  Pen.Color:=Color;
  Brush.Color:=Color;
  Ellipse(Offset2,Offset2,Width-Offset2,Height-Offset2);

  Pen.Color:=clWhite;
  Pen.Width:=2;
  GradToCoords(StartA,EndA,sA,eA);
  Arc(Offset2,Offset2,Width-Offset2,Height-Offset2,
      midX+sA.X,midY-sA.Y,midX+eA.X,midY-eA.Y);
  end;
end;

Procedure TASMetr.DrawTicks;
var
   tmpStartA:Integer;
   i,j:Integer;
begin
With Canvas Do
 begin
 Brush.Color:=clBlack;
 GradValues(TickCount);
 iGrad:=Trunc(t1);
 StartA:=270+Trunc(p2 / 2);
 EndA:=270-Trunc(p2 / 2);

 GradToCoords(StartA,EndA,sA,eA);

 Brush.Style:=bsSolid;
 Pen.Color := clBlack;
 Brush.Color:=Color;
 Pen.Width:=1;

 tmpStartA:=StartA;

 For j:=1 To TickCount+1 Do
  begin
  GradToCoords(StartA,EndA,sA,eA);

  ValuesTicks(StartA,Offset2+10);
  MoveTo(CoordPointX,CoordPointY);
  ValuesTicks(StartA,Offset2);
  LineTo(CoordPointX,CoordPointY);

  If FPrintValues Then
   begin
   wText:=TextWidth(IntToStr((FSliding*FMax)-(j-1)*FSliding));
   hText:=TextHeight(IntToStr((FSliding*FMax)-(j-1)*FSliding));
   ValuesTicks(StartA,Offset2+Round(hText*2.5));
   TextValuesForTicks(spInside);

   TextOut(CoordPointX,CoordPointY,
          IntToStr((FSliding*FMax)-(j-1)*FSliding));
   end;
  ValuesTicks(StartA,Offset2+10);
  MoveTo(CoordPointX,CoordPointY);
  ValuesTicks(StartA,Offset2);
  LineTo(CoordPointX,CoordPointY);
  Inc(StartA,iGrad);
  end;
end;
end;

Procedure TASMetr.DrawPointer;
var
   tW,tH,
   tX,tY:Integer;
   An,i:Integer;
   sp:String;
begin
With Canvas Do
 begin
 Brush.Style:=bsClear{bsSolid};
 Pen.Color := Self.Color;
 Brush.Color:=Self.Color;
 Pen.Width:=3;
 end;
 GradValues(TickCount);
 With Canvas Do
  begin
  iGrad:=Trunc(t1);
  EndA:=270-Trunc(p2 / 2);
  StartA:=270+Trunc(p2 / 2);
  An:=EndA;
  EndA:=EndA+360-(iGrad*(PositionOld div FSliding));
  midX:=Width div 2;
  midY:=Height div 2;
  Pen.Width:=3;
  MoveTo(midX,midY);
  ValuesTicks(EndA,Offset2);
  Pen.Color:=Self.Color;
  Brush.Color:=Self.Color;
  LineTo(CoordPointX,CoordPointY);

  Pen.Mode:=pmCopy;
  Pen.Color:=$00909090;
  Pen.Width:={2}1;
  ValuesTicks(An,Offset);
  MoveTo(CoordPointX,CoordPointY);
  ValuesTicks(An,Offset2);
  LineTo(CoordPointX,CoordPointY);
  Pen.Color:=Self.Color;

  Pen.Mode:=pmCopy;
  Pen.Color:=clBlack;
  Brush.Color:=Self.Color;
  EndA:=270-Trunc(p2 / 2);
  EndA:=EndA+360-(iGrad*(PositionNatur div FSliding));
  midX:=Width div 2;
  midY:=Height div 2;
  Pen.Width:=3;
  MoveTo(midX,midY);
  ValuesTicks(EndA,Offset2);
  LineTo(CoordPointX,CoordPointY);

  If not PrintValues Then
   begin
   Brush.Color:=Self.Color;
   Brush.Style:=bsSolid;
   tW:=TextWidth(Format('%d',[FPosition*FSliding]));
   tH:=TextHeight(Format('%d',[FPosition*FSliding]));
   Pen.Color:=clBlack;
   For i:=1 To tW*2 Do sp:=sp+' ';
   TextOut(midX-5,Height-30,Format('%s',[sp]));
   TextOut(midX-5,Height-30,Format('%d',[FPosition*FSliding]));
   end;
  DrawTicks;
  end;
end;

Procedure TASMetr.Paint;
begin
 If FMax=0
  Then TickCount:=FMax+1
  Else TickCount:=FMax;
 Height:=Width;
 midX:=Width div 2;
 midY:=Height div 2;
 With Canvas Do
  begin
  Brush.Style:=bsClear;
  Brush.Color:=Self.Color;
  FillRect(ClientRect);
  Dest:=Rect(0,0,Width,Height);
  DrawFace;
  DrawTicks;
  DrawPointer;
  Pen.Color:=clSilver;
  Brush.Style:=bsClear;

  Brush.Color:=clGreen;
  Ellipse(midX-8,midY-8,midX+8,
          midY+8);
  end;
end;

Procedure TASMetr.SetPosition(Value:Integer);
var
   SoundFile:String;

   FindResHandle:THandle;
   LoadResHandle:THandle;
   LockResPointer:Pointer;
begin
If Value <> FPosition Then
 begin
 If Value >FMax Then Value:=FMax;
 If Value <0 Then Value:=0;
 PositionOld:=PositionNatur;
 PositionNatur:=Value*FSliding;
 FPosition:=Value;
 If csDesigning in ComponentState
  Then Invalidate
  Else
   begin
   If FMax=0
    Then TickCount:=FMax+1
    Else TickCount:=FMax;

   With Canvas Do
    begin
    DrawPointer;
    Pen.Color:=clSilver;
    Brush.Style:=bsClear;

    Brush.Color:=clGreen;
    Ellipse(midX-8,midY-8,midX+8,
            midY+8);
    end;

    If FSoundType <> wssNone Then
     begin
     FWaveOptions:=0;
     If woSync In WaveOptions
     Then
       FWaveOptions := FWaveOptions Or SND_SYNC
     Else
       FWaveOptions := FWaveOptions Or SND_ASYNC;
     If woNoDefault In WaveOptions
     Then
       FWaveOptions := FWaveOptions Or SND_NODEFAULT;
     If woLoop In WaveOptions
     Then
       FWaveOptions := FWaveOptions Or SND_LOOP;
     If woNoStop In WaveOptions
     Then
       FWaveOptions := FWaveOptions Or SND_NOSTOP;

     SoundFile:='';
     If Position = FAttenZonePos Then SoundFile:=FAttenZoneSound;
     If Position = FDangerZonePos Then SoundFile:=FDangerZoneSound;
     If Position = FMax Then SoundFile:=FOverflowSound;

     If FSoundType = wssWav
      Then
       sndPlaySound(PChar(SoundFile),FWaveOptions)
      Else
       begin
       FindResHandle := FindResource(HInstance,PChar(SoundFile),PChar(FResourceType));
       If FindResHandle = 0
        Then Abort {Resource not found}
        Else
         begin
         LoadResHandle := LoadResource(HInstance,FindResHandle);
         If LoadResHandle = 0
          Then Abort {Resource not load}
          Else
           begin
           LockResPointer := LockResource(LoadResHandle);
           If LockResPointer = Nil
            Then
             begin
             FreeResource(LoadResHandle);
             Abort; {Can't lock resource}
             end
            Else
             begin
             sndPlaySound(LockResPointer,FWaveOptions Or SND_MEMORY);
             end;
           end;
         end;
        end;
       end;
   end;
 end;
end;

Procedure TASMetr.SetMax(Value:Integer);
begin
If Value <> FMax Then
 begin
 If (Value >= 0)and(Value <= 270) Then FMax:=Value;
 If FMax=0
  Then TickCount:=FMax+1
  Else TickCount:=FMax;
 DrawPointer;
 Invalidate;
 Width:=Width+1;
 Width:=Width-1;

 FDangerZonePos:=Value-1;
 FAttenZonePos:=Value-2;
 end;
end;

Procedure TASMetr.SetSliding(Value:Integer);
begin
If Value <> FSliding
 Then
  begin
  If Value<=0 Then Value:=1;
  FSliding:=Value;
  Invalidate;
  end;
end;

Procedure TASMetr.SetPrintValues(Value:Boolean);
begin
If Value <> FPrintValues
 Then
  begin
  FPrintValues:=Value;
  Invalidate;
  end;
end;

Procedure TASMetr.SetAttenZonePos(Value:Integer);
begin
If Value <> FAttenZonePos
 Then
  begin
  If Value < 1
   Then FAttenZonePos:=1
   Else
    If Value >= FDangerZonePos
     Then FAttenZonePos:=FDangerZonePos-1
     Else FAttenZonePos:=Value;
  Invalidate;
  end;
end;

Procedure TASMetr.SetDangerZonePos(Value:Integer);
begin
If Value <> FDangerZonePos
 Then
  begin
  If Value >= FMax
   Then FDangerZonePos:=FMax-1
   Else FDangerZonePos:=Value;
  Invalidate;
  end;
end;

Procedure TASMetr.SetAttenZoneColor(Value:TColor);
begin
If Value <> FAttenZoneColor
 Then
  begin
  FAttenZoneColor:=Value;
  Invalidate;
  end;
end;

Procedure TASMetr.SetDangerZoneColor(Value:TColor);
begin
If Value <> FDangerZoneColor
 Then
  begin
  FDangerZoneColor:=Value;
  Invalidate;
  end;
end;

Procedure TASMetr.SetAttenZoneSound(Value:String);
begin
If Value <> FAttenZoneSound
 Then
  FAttenZoneSound:=Value;
end;

Procedure TASMetr.SetDangerZoneSound(Value:String);
begin
If Value <> FDangerZoneSound
 Then
  FDangerZoneSound:=Value;
end;

Procedure TASMetr.SetOverflowSound(Value:String);
begin
If Value <> FOverflowSound
 Then
  FOverflowSound:=Value;
end;

Procedure TASMetr.SetSoundType(Value:TWhereSoundStore);
begin
If Value <> FSoundType
 Then FSoundType:=Value;
end;

Procedure TASMetr.SetResourceType(Value:String);
begin
If Value <> FResourceType
 Then FResourceType:=Value;
end;

procedure Register;
begin
  RegisterComponents('AbakSoft', [TASMetr]);
  RegisterPropertyEditor(TypeInfo(String),
     TASMetr,'AttenZoneSound',TASSoundFileChange);
  RegisterPropertyEditor(TypeInfo(String),
     TASMetr,'DangerZoneSound',TASSoundFileChange);
  RegisterPropertyEditor(TypeInfo(String),
     TASMetr,'OverflowSound',TASSoundFileChange);
end;

end.
